
function PsychicCinematic()

	local CinemaInvader  = G.CreateAt( "Psychic", Vector3( 135, 0, 135 ) );
	local CinemaInvader2  = G.CreateAt( "Psychic", Vector3( 150, 0, 120 ) );
	local CinemaInvader3  = G.CreateAt( "Psychic", Vector3( 115, 0, 145 ) );
--	local CinemaInvader4  = G.CreateAt( "Psychic", Vector3( 115, 0, 140 ) );
	
--	G.dg( "doodads" );

	CinemaInvader.TurnOffAI()
	CinemaInvader2.TurnOffAI()
	CinemaInvader3.TurnOffAI()
--	CinemaInvader4.TurnOffAI()
	
	Camera.CinemaMove( Vector3(175,15,175), Vector3(130,10,130), 3 );
	TraitorTalk( "I hear something in my mind? Huh?" );
	GameWait(3)
	
	CinemaInvader.SetVelocity( Vector3(0,0,0) )
	CinemaInvader2.SetVelocity( Vector3(0,0,0) )
	CinemaInvader3.SetVelocity( Vector3(0,0,0) )
	
	TraitorTalk( "Psychics!" )	
	GameWait(1)
	
	G.SayPhraseScript( "Looking for \nthese?" , CinemaInvader );
--	CinemaInvader.SetAnimation("Special", false);
	
	GameWait(1)
	CinemaInvader.PlaySound3D( "Special" );
	TrapPlace( "wall", Vector3(132,0,140), Vector3(1,0,0));
	G.CreateAt( "PsychicSphere" , Vector3(132,0,140) );
	GameWait(1)

--	CinemaInvader.SetAnimation("Walk", true);
	
	TraitorTalk( "So they're responsible for moving all our walls!" );

	GameWait(0.5)
	G.SayPhraseScript( "Ha ha ha!" , CinemaInvader );
	GameWait(0.5)
	G.SayPhraseScript( "We so smart!" , CinemaInvader2 );
	GameWait(0.5)
	G.SayPhraseScript( "Dimwits!" , CinemaInvader3 );
	GameWait(0.5)

	GameWait(1)
	G.SayPhraseScript( "I calculated \n the best\n attack," , CinemaInvader );

	GameWait(0.5)
	G.SayPhraseScript( "Me too!" , CinemaInvader2 );
	GameWait(0.5)
	G.SayPhraseScript( "I did it!" , CinemaInvader3 );
	GameWait(0.5)
--	G.SayPhraseScript( "So did I!" , CinemaInvader4 );
	GameWait(0.5)

	G.SayPhraseScript( "Using math\n I determined \n that:" , CinemaInvader );

	GameWait(0.5)
	G.SayPhraseScript( "What he Said!" , CinemaInvader2 );
	GameWait(0.5)
	G.SayPhraseScript( "Ditto!" , CinemaInvader3 );
	GameWait(0.5)
--	G.SayPhraseScript( "Yeah!" , CinemaInvader4 );
	GameWait(0.5)

	G.SayPhraseScript( "Without walls\n you have\n no base!" , CinemaInvader );

	GameWait(0.5)
	G.SayPhraseScript( "Exactly!" , CinemaInvader2 );
	GameWait(0.5)
	G.SayPhraseScript( "Right on!" , CinemaInvader3 );
	GameWait(0.5)
--	G.SayPhraseScript( "True!" , CinemaInvader4 );
	GameWait(0.5)

	TraitorTalk( "Darn those Psychics!" );
	GameWait(1)

	G.SayPhraseScript( "Ha ha ha!" , CinemaInvader );
	GameWait(0.5)
	G.SayPhraseScript( "Ha ha ha!!" , CinemaInvader2 );
	GameWait(0.5)
	G.SayPhraseScript( "Ha ha ha!!!" , CinemaInvader3 );
	GameWait(0.5)

	CinemaInvader.TurnOnAI()
	CinemaInvader2.TurnOnAI()
	CinemaInvader3.TurnOnAI()
--	CinemaInvader4.TurnOnAI()
	
end


--Common Level Start Code
function LevelStartup()

	G.Create( "MenuData/HudCog.xml" );
	G.Create( "Data/GameCamera.xml" );
	G.Create( "Data/CursorCog.xml" );

	MainLevel = G.Create( "Data/Levels/Campaign7.xml" );
	MainLevel.CreateLevel();

	G.SetInvSpeed( 20 );
	HUD.EnterLevel();
	G.SetGameState( InLevel );
	G.SetPoints( 0 );
	
	G.SetLightTime( 5 );
	G.PostP( "None" );
	--TraitorTalk(" ");

	-- gameStartTime = 10000000;

	HUD.Message( "VictoryCondition" , "SetText", "Psyche out the Psychic Invasion!"  );
	HUD.Message( "LossCondition" , "SetText", "If the Tower falls you lose." );
		
	TraitorCanBeHidden = true
end

LevelStartup()

function LevelIntro()
	
	local tempPos = Tower.GetPosition()
	Camera.LookAtPosition( tempPos )

	gameStartTime = GameTime;

	ResetTextPopupTiming();
	ColorTextPopup( "Level 7: Multi-Dimensional", Color(1,1,1,1) )

	G.DisableTrapAll()
		
	G.EnableTrap("bomb");
	
	G.EnableTrap("spring");
	G.EnableTrap("laser");
	G.EnableTrap("flame");	

	DisableTraitor()
	GameWait(1.5)
	
	G.EarnPoints( 150 );
	
--	StartCinematic()
--		PsychicCinematic()
--	EndCinematic()
			
end

SpawnPoints = {}

function LevelSequence()
	
	-- 1st Have a tower and some walls and let the Basic guys attack.
	Traitor.SetGuiPosition( "TraitorWindow"  , Vector3(0.6, -0.5, 1) );
	
	-- Set the spawn points
		
	-- Start Spawning the guys
	BasicWave = createSpawnStruct()
	
	BasicWave.Prob.Basic	= 2.0;
	BasicWave.Prob.Miner	= 1.0;
	BasicWave.Prob.Spiker	= 1.0;
	BasicWave.Prob.Bomber	= 0.5;
	
	BasicWave.SpawnSpeed	= 2.0;
	BasicWave.MaxSpawn		= 15;
	BasicWave.TotalSpawn	= 25;
	BasicWave.GroupPercent	= 0.15;
	BasicWave.GroupSize		= 1;
	BasicWave.WhereToSpawn	= SmallCircleAroundTower
			
	PsychicWave = createSpawnStruct()
	
	PsychicWave.Prob.Psychic	= 1.0;
	
	PsychicWave.SpawnSpeed		= 0.4;
	PsychicWave.MaxSpawn		= 15;
	PsychicWave.TotalSpawn		= 22;
	PsychicWave.GroupPercent	= 0.15;
	PsychicWave.GroupSize		= 1;
	PsychicWave.WhereToSpawn	= SmallCircleAroundTower
		
	TraitorTalk("These defenses look pretty good.  Now time to add the walls.")
	GameWait(6)
	TraitorTalk("Umm... where're the walls?")
	GameWait(5)
	TraitorTalk("What the heck?!?  Where'd they go?")
	GameWait(5)
	TraitorTalk("Oh no, they're coming!")
	
	AddWave( "BasicAttack", BasicWave )
	G.SetMaxKills(25);
	
	GameWait(3)
	
	InvadersKilledWait(25)
	
	GameWait(4)
	
	TraitorTalk("Wow, that's a lot tougher without any walls...  but we managed pretty well.");
	GameWait(7)
	TraitorTalk("Ya know, I have these blueprints...  maybe they can help you.");
	GameWait(3)
	
	TrapTextPopup("Vortex")	
	G.EarnPoints( 125 )
	G.EnableTrap("vortex");
	GameWait(2)	
	
	TraitorTalk("I don't know how it works exactly...")
	GameWait(5)
	TraitorTalk("But I know they suck invaders in that get too close.")
	GameWait(5)
	TraitorTalk("I'm not sure where it leads to, but who cares?  As long as it gets rid of 'em!")
	GameWait(7)
	TraitorTalk("Place some Vortex Traps down, lets see how they work.");
	GameWaitOrMoney(10)
	
	TraitorTalk("I see more coming...  hurry up!");
	GameWait(3)
	BasicWave.TotalSpawn = 50;
	G.SetMaxKills(75)
	InvadersKilledWait(75)
	
	GameWait(3)
	
	TraitorTalk("That made things a lot easier.  These things are awesome!");
	GameWait(6)
	TraitorTalk("Nothing can stand up against these Vortex Traps!");
	GameWait(4)
	
	StartCinematic()
		PsychicCinematic()
	EndCinematic()	
	
	InvaderTextPopup( "Psychic" );
	GameWait(2)
	
	TraitorTalk("They use their Psychic abilities to move around traps that get in their way.")
	GameWait(7)
	TraitorTalk("They occasionally kill themselves in the process, but they're still dangerous.")
	GameWait(7)
	
	AddWave( "PsychicAttack", PsychicWave )
	G.SetMaxKills(100);

	TraitorTalk("The Psychics can float over our springs! Use lasers or throw them!")
	GameWait(7)

	
	InvadersKilledWait(100)	
	StopWave( "PsychicAttack" )
	
	GameWait(3)
	
	TraitorTalk("Whoa, those psychics are also immune to Vortex Traps!  I didn't know that.")
	GameWait(10)
	TraitorTalk("Yikes, more are on the way.  Build up the base, fast!");
	G.EarnPoints(100)
	GameWaitOrMoney(25)
	
	BasicWave.TotalSpawn = 75
	BasicWave.Prob.Psychic = 1.5
	
	G.SetMaxKills(175);
	InvadersKilledWait(175)
	
	GameWait(3)	
	
	TraitorTalk("Hooray!  You did it!")
	GameWait(3)
	TraitorTalk("They're gone for now, but they'll be back soon.")
	GameWait(4)
	TraitorTalk("It's time we moved on.")
	GameWait(4)
	DisableTraitor()
	GameWait(1)
	
	TraitorTalk("Hey, guess what ...")
	GameWait(2)
	ColorTextPopup( "Recovered Trap: Walls!", Color(0.25,0.25,1,1) )
	
	TraitorTalk("I recovered the walls!")
	G.EnableTrap("wall")
	GameWait(3)
	G.SetGameState( Victory );	
end

levelRoutine = coroutine.create(LevelIntro);

GMain["LevelUpdate"] = LevelUpdate;
