;InnoSetupVersion=5.1.2

[Setup]
AppName=Base Invaders
AppVerName=Base Invaders Version 1.3
AppId=Base Invaders
DefaultDirName={pf}\BaseInvaders
DefaultGroupName=BaseInvaders
UninstallDisplayIcon={app}\CORE.exe
OutputBaseFilename=setup
Compression=lzma
PrivilegesRequired=none
LicenseFile=embedded\License.txt
WizardImageFile=embedded\WizardImage0.bmp
WizardSmallImageFile=embedded\WizardSmallImage0.bmp

[Files]
Source: "{app}\CORE.exe"; DestDir: "{app}"; 
Source: "{app}\InvaderLoading.bmp"; DestDir: "{app}"; 
Source: "{app}\fmod.dll"; DestDir: "{app}"; 
Source: "{app}\Config.xml"; DestDir: "{app}"; 
Source: "{sys}\d3dx9_30.dll"; DestDir: "{sys}"; Flags: uninsneveruninstall onlyifdoesntexist 
Source: "{app}\Config\AI.xml"; DestDir: "{app}\Config"; 
Source: "{app}\Config\AudioConfig.xml"; DestDir: "{app}\Config"; 
Source: "{app}\Config\Graphics.xml"; DestDir: "{app}\Config"; 
Source: "{app}\Config\GuiConfig.xml"; DestDir: "{app}\Config"; 
Source: "{app}\Config\IOConfig.xml"; DestDir: "{app}\Config"; 
Source: "{app}\Config\Logic.xml"; DestDir: "{app}\Config"; 
Source: "{app}\Config\LogicData.xml"; DestDir: "{app}\Config"; 
Source: "{app}\Config\Methods.xml"; DestDir: "{app}\Config"; 
Source: "{app}\Config\PhraseBank.xml"; DestDir: "{app}\Config"; 
Source: "{app}\Config\Physics.xml"; DestDir: "{app}\Config"; 
Source: "{app}\Config\QTree.xml"; DestDir: "{app}\Config"; 
Source: "{app}\Compositions\BaseTowerComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\BasicCameraComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\BombComp.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\CameraComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\CapeFollower.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\CursorComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\Doodad.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\ExplosionChunkComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\ExplosionComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\GeneralEffect.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\HUDComp.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\HUDComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\InvaderComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\InvaderDeathEffect.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\LaserBulletComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\LevelComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\LightComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\MenuComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\ModelComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\ModelFollower.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\NoCollideTrap.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\ParticleFollowerComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\PhysicsBallComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\PoisonMistComposion.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\SatelliteComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\SkinModel.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\SpeechBubble.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\SpringTest.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\SquadLeaderComp.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\StaticColliderComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\StaticModelComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\TerrainComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\TraitorComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\TrapComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\TrapDropperComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Compositions\WallComposition.xml"; DestDir: "{app}\Compositions"; 
Source: "{app}\Textures\Arrow.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\ArrowTex.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\AxeTrap.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BarEdge.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BaseLevel1Texture.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BaseLevel2Texture.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BaseLevel3ExtrasTexture.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BaseLevel3Texture.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BaseLevel4Texture.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BaseLevel5Texture.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BasicTextureB.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BasicTextureBBlind.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BasicTextureBDumb.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BasicTextureBHappy.PNG"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Black.bmp"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Blast0.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Blast1.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Blast2.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BlueBev.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BlueGlow.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BomberInv.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BomberInvBlind.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BomberInvDumb.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BulbTrap.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\BulbTrapLightMask.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Bus.tga"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Bush.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Bush2.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Bush3.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Church.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\clouds.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\cloudsbump.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\ColorBlend.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Cracked.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Desert2.bmp"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\DirtTest1.bmp"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\DP512.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\DrillerInv.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\DrillerInvBlind.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\DrillerInvDumb.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\DWordBubble.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\edgedirt.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\FanTrap.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\FinalFrontHeightMap.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\FireTrap.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Flash.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\GameOver.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\GearLogo.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\GearTrans.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\GradBars.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\GrassTest1.bmp"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\grit.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\GRock.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\GUI23.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\HammerTrap.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\HandTexture.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\heightmap.bmp"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Heightmap.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Heightmap2.bmp"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\HUDWindowBack.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Info1.bmp"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\InfoC.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\InvaderBack.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\InvaderIcons.tga"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\KamikazeInv.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\KamikazeInvBlind.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\KamikazeInvDumb.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Laser.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\LaserBlast.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\LaserTrap.PNG"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\LifeBack.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\LifeBackFill.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\light.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\LogoTex.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Logo_2.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\MainHeightMap.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\MainInfoMap.bmp"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\MapBorder.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\MenuBackground.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\MinerInv.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\MinerInvBlind.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\MinerInvDumb.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Minimap Icons.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\MissileTrap.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Mouse.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Mushroom.tga"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Mushroom2.tga"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Mushroom3.tga"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\MushroomLight.tga"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\NewBar.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\NinjaInv.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\NinjaInvBlind.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\NinjaInvDumb.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\panels.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\panelsc.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\ParachuteLogo.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\PitTrap.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\PoisonTrap.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\PsychicInv.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\PsychicInvBlind.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\PsychicInvDumb.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\RadarBack.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\RBush.tga"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\RedBeam.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\rock.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\rocko.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\RockyInfoMap.bmp"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\RTree.tga"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\SatelliteTrap.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\SevenLogo.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\ShadowDot.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\smoke.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Smoke0.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Smoke1.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Smoke2.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\spike.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\SpikerInv.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\SpikerInvB.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Spring Trap.PNG"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\SquadInv.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\SquadInvBlind.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\SquadInvDumb.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\StackerInv.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\StackerInvBlind.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\StackerInvDumb.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\stars.bmp"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Stars.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\StatusIcons.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\stone.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\SwirlyBlur.tga"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\SWordBubble.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\TextBackground.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Titles.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\Tun1.bmp"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\TutorialHeightMap.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\vase.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\VICTORY.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\VortexTrap.dds"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\VortexTrap.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\WallTrap.PNG"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\WallTrap2.PNG"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\White.bmp"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\WordBubbleTip.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\ZapperTrap.png"; DestDir: "{app}\Textures"; 
Source: "{app}\Textures\ConceptArt\Basic.png"; DestDir: "{app}\Textures\ConceptArt"; 
Source: "{app}\Textures\ConceptArt\Bomber.png"; DestDir: "{app}\Textures\ConceptArt"; 
Source: "{app}\Textures\ConceptArt\Driller.png"; DestDir: "{app}\Textures\ConceptArt"; 
Source: "{app}\Textures\ConceptArt\Kamikaze.png"; DestDir: "{app}\Textures\ConceptArt"; 
Source: "{app}\Textures\ConceptArt\Miner.png"; DestDir: "{app}\Textures\ConceptArt"; 
Source: "{app}\Textures\ConceptArt\Ninja.png"; DestDir: "{app}\Textures\ConceptArt"; 
Source: "{app}\Textures\ConceptArt\Psychic.png"; DestDir: "{app}\Textures\ConceptArt"; 
Source: "{app}\Textures\ConceptArt\Spiker.png"; DestDir: "{app}\Textures\ConceptArt"; 
Source: "{app}\Textures\ConceptArt\Squad.png"; DestDir: "{app}\Textures\ConceptArt"; 
Source: "{app}\Textures\ConceptArt\Stacker.png"; DestDir: "{app}\Textures\ConceptArt"; 
Source: "{app}\Textures\InvaderIcons\Basic.tga"; DestDir: "{app}\Textures\InvaderIcons"; 
Source: "{app}\Textures\InvaderIcons\Bomber.tga"; DestDir: "{app}\Textures\InvaderIcons"; 
Source: "{app}\Textures\InvaderIcons\Driller.tga"; DestDir: "{app}\Textures\InvaderIcons"; 
Source: "{app}\Textures\InvaderIcons\Kamikaze.tga"; DestDir: "{app}\Textures\InvaderIcons"; 
Source: "{app}\Textures\InvaderIcons\Miner.tga"; DestDir: "{app}\Textures\InvaderIcons"; 
Source: "{app}\Textures\InvaderIcons\Ninja.tga"; DestDir: "{app}\Textures\InvaderIcons"; 
Source: "{app}\Textures\InvaderIcons\Psychic.tga"; DestDir: "{app}\Textures\InvaderIcons"; 
Source: "{app}\Textures\InvaderIcons\Spiker.tga"; DestDir: "{app}\Textures\InvaderIcons"; 
Source: "{app}\Textures\InvaderIcons\Squad.tga"; DestDir: "{app}\Textures\InvaderIcons"; 
Source: "{app}\Textures\InvaderIcons\Stacker.tga"; DestDir: "{app}\Textures\InvaderIcons"; 
Source: "{app}\Textures\LevelPics\Campaign1.png"; DestDir: "{app}\Textures\LevelPics"; 
Source: "{app}\Textures\LevelPics\Campaign10.png"; DestDir: "{app}\Textures\LevelPics"; 
Source: "{app}\Textures\LevelPics\Campaign2.png"; DestDir: "{app}\Textures\LevelPics"; 
Source: "{app}\Textures\LevelPics\Campaign3.png"; DestDir: "{app}\Textures\LevelPics"; 
Source: "{app}\Textures\LevelPics\Campaign4.png"; DestDir: "{app}\Textures\LevelPics"; 
Source: "{app}\Textures\LevelPics\Campaign5.png"; DestDir: "{app}\Textures\LevelPics"; 
Source: "{app}\Textures\LevelPics\Campaign6.png"; DestDir: "{app}\Textures\LevelPics"; 
Source: "{app}\Textures\LevelPics\Campaign7.png"; DestDir: "{app}\Textures\LevelPics"; 
Source: "{app}\Textures\LevelPics\Campaign8.png"; DestDir: "{app}\Textures\LevelPics"; 
Source: "{app}\Textures\LevelPics\Campaign9.png"; DestDir: "{app}\Textures\LevelPics"; 
Source: "{app}\Textures\LevelPics\Challenge.png"; DestDir: "{app}\Textures\LevelPics"; 
Source: "{app}\Textures\LevelPics\Mask.png"; DestDir: "{app}\Textures\LevelPics"; 
Source: "{app}\Textures\LevelPics\Tutorial.png"; DestDir: "{app}\Textures\LevelPics"; 
Source: "{app}\Textures\StatusIcons\AURA.png"; DestDir: "{app}\Textures\StatusIcons"; 
Source: "{app}\Textures\StatusIcons\BLIND.png"; DestDir: "{app}\Textures\StatusIcons"; 
Source: "{app}\Textures\StatusIcons\DUMB.png"; DestDir: "{app}\Textures\StatusIcons"; 
Source: "{app}\Textures\StatusIcons\FIRE.png"; DestDir: "{app}\Textures\StatusIcons"; 
Source: "{app}\Textures\StatusIcons\FROST.png"; DestDir: "{app}\Textures\StatusIcons"; 
Source: "{app}\Textures\StatusIcons\KILLS.png"; DestDir: "{app}\Textures\StatusIcons"; 
Source: "{app}\Textures\StatusIcons\MAD.png"; DestDir: "{app}\Textures\StatusIcons"; 
Source: "{app}\Textures\StatusIcons\METAL.png"; DestDir: "{app}\Textures\StatusIcons"; 
Source: "{app}\Textures\StatusIcons\POISONED.png"; DestDir: "{app}\Textures\StatusIcons"; 
Source: "{app}\Textures\StatusIcons\StatusIcons.png"; DestDir: "{app}\Textures\StatusIcons"; 
Source: "{app}\Textures\StatusIcons\TIME.png"; DestDir: "{app}\Textures\StatusIcons"; 
Source: "{app}\Textures\TraitorPics\Traitor001.png"; DestDir: "{app}\Textures\TraitorPics"; 
Source: "{app}\Textures\TraitorPics\Traitor002.png"; DestDir: "{app}\Textures\TraitorPics"; 
Source: "{app}\Textures\TraitorPics\Traitor003.png"; DestDir: "{app}\Textures\TraitorPics"; 
Source: "{app}\Textures\TraitorPics\Traitor004.png"; DestDir: "{app}\Textures\TraitorPics"; 
Source: "{app}\Textures\TraitorPics\Traitor005.png"; DestDir: "{app}\Textures\TraitorPics"; 
Source: "{app}\Textures\TraitorPics\Traitor006.png"; DestDir: "{app}\Textures\TraitorPics"; 
Source: "{app}\Textures\TraitorPics\Traitor007.png"; DestDir: "{app}\Textures\TraitorPics"; 
Source: "{app}\Textures\TraitorPics\Traitor008.png"; DestDir: "{app}\Textures\TraitorPics"; 
Source: "{app}\Textures\TraitorPics\TraitorBlink1-3.png"; DestDir: "{app}\Textures\TraitorPics"; 
Source: "{app}\Textures\TraitorPics\TraitorBlink2.png"; DestDir: "{app}\Textures\TraitorPics"; 
Source: "{app}\Textures\TrapIcons\Axes.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Bomb.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Button.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Fan.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Fire.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Flash.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Hammer.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Highlight.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\HighlightBox.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Lazer.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Missile.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Normal.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\NormalBox.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Pit.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Poison.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Satellite.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Spring.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Vortex.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Wall.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\Textures\TrapIcons\Zapper.png"; DestDir: "{app}\Textures\TrapIcons"; 
Source: "{app}\SFX\9th.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\AxeHit1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\AxeHit2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BasicAttack1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BasicAttack2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BasicAttack3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BasicAttack4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BomberBounce1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BomberBounce2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BomberBounce3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BomberBounce4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BomberThrow1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BomberThrow2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BomberThrow3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BomberThrow4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\Book Hit.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\Boom1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BulbActivate1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\BulbActivate2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\DrillerAttack1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\DrillerAttack2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\DrillerBounce1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\DrillerBounce2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\DrillerBounce3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\DrillerBounce4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\DrillerSpecial1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\DrillerSpecial2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\DrillerThrow1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\DrillerThrow2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\Explode1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\Explode2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\FlameActivate1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\FlameActivate2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\HammerHit1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\HammerHit2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\HammerHit3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\HammerReset1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\HammerReset2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\HitSound1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\HitSound2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\HitSound3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\HitSound4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\InvaderSounds.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\InvaderSquish1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\InvaderSquish2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\InvaderSquish3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\InvaderSquish4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\InvaderVoiceSounds.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\KamikazeBounce1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\KamikazeBounce2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\KamikazeBounce3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\KamikazeBounce4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\KamikazeSounds.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\KamikazeSpecial1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\KamikazeSpecial2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\KamikazeSpecial3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\KamikazeSpecial4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\KamikazeThrow1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\KamikazeThrow2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\KamikazeThrow3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\KamikazeThrow4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\LaserActivate1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\LaserActivate2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MinerAttack1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MinerAttack2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MinerAttack3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MinerAttack4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MinerBounce1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MinerBounce2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MinerBounce3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MinerBounce4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MinerThrow1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MinerThrow2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MinerThrow3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MinerThrow4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MissileActivate.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MissileExplosion1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\MissileExplosion2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\NinjaAttack1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\NinjaAttack2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\PoisonActivate1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\PoisonActivate2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\Poke.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\Poof1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\PsychicBounce1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\PsychicBounce2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\PsychicBounce3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\PsychicBounce4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\PsychicSpecial1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\PsychicSpecial2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\PsychicThrow1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\PsychicThrow2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\PsychicThrow3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\PsychicThrow4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\SmallBoom1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\SmallBoom2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\SmallBoom3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\SomeSounds.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\SpikerBounce1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\SpikerBounce2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\SpringActivate1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\SpringActivate2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\springTrap.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\StackerBounce1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\StackerBounce2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\StackerBounce3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\StackerBounce4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\StackerSounds.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\StackerThrow1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\StackerThrow2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\StackerThrow3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\StackerThrow4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\ThrowSound1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\ThrowSound2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\ThrowSound3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\ThrowSound4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\Thunder.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\TraitorTalk1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\TraitorTalk2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\TraitorTalk3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\TraitorTalk4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\TraitorTalkShort1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\TraitorTalkShort2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\TraitorTalkShort3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\TraitorTalkShort4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\TraitorTalkShort5.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\TraitorTalkShort6.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\TraitorTalkShort7.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\TraitorTalkShort8.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\TraitorTalkShort9.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\ZapperActivate1.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\ZapperActivate2.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\ZapperActivate3.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\SFX\ZapperActivate4.ogg"; DestDir: "{app}\SFX"; 
Source: "{app}\Models\Arrow.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\AxeTrap.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Axis.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Ball.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\BaseTower.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\BasicDM.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\BasicInv.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\BigArrow.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Bomb.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\BomberDM.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\BomberInv.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\BulbTrap.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Bus.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Bush.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Bush1.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Bush2.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\ChamBox.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Church.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Cone.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\DrillerDM.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\DrillerInv.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\EffectTest.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Fan.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\FireTrap.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\GearExp.dle"; DestDir: "{app}\Models"; 
Source: "{app}\Models\HammerTrap.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Hand.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\HandDM.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\HandOld.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\InvaderDM.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\KamikazeDM.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\KamikazeInv.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\LaserTrap.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Letters.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Logo.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\MinerDM.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\MinerInv.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\MissileTrap.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Mushroom.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\NinjaDM.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\NinjaInv.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\OldHammer.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Parachute.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\pitdoodad.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\PitTrap.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Plane.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\PoisonTrap.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\PsychicDM.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\PsychicInv.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\RingDM.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Rock.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Rock1.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Rock2.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\SatelliteBase.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\SatelliteCombo.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\SatelliteTrap.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\SevenTex.3ds"; DestDir: "{app}\Models"; 
Source: "{app}\Models\skydome.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\SocBall.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\SphereDM.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\SpikerDM.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\SpikerInv.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Spin.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\SpringTrap.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\SquadDM.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\SquadInv.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\StackerDM.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\StackerInv.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\TileCube.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Torus.3ds"; DestDir: "{app}\Models"; 
Source: "{app}\Models\TrapCube.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Tree.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Tree2.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\UnitCube.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\UnitSphere.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Vase.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\VortexEffect.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\VortexTrap.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\WallTrap.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\WallTrap2.gmf"; DestDir: "{app}\Models"; 
Source: "{app}\Models\Water.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Models\ZapperTrap.GMF"; DestDir: "{app}\Models"; 
Source: "{app}\Particles\AlphaCloud.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\bulletb.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\Cloud.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\CStar.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\dirtysmallsmoke.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\Drop.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\Flare.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\note.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\particle.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\plus.PNG"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\qmark.PNG"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\Rain.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\Simple.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\smallsmoke.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\smoke.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\smokeswirl2.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\smokeswirl4.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\snowflake.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\splat.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\Star.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\Star2.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Particles\swirl.png"; DestDir: "{app}\Particles"; 
Source: "{app}\Scripts\Alpha.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Campaign10Startup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Campaign1Startup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Campaign2Startup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Campaign3Startup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Campaign3StartupOld.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Campaign4Startup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Campaign5Startup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Campaign6Startup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Campaign7Startup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Campaign8Startup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Campaign9Startup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\CinemaSystem.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\DefaultLevelConfig.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Deferred.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\GameOver.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\GameSettings.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\GTest.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\HudTest.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Init.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Intro.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\IntroImagePopup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\InvaderBowling.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\LargeTextPopup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Level1Startup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\LevelConfig.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\LevelOneSpawners.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\MainMenu.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\NightTest.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\PhysicsStartup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\PhysPresent.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\QuickStartSpawners.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\QuickStartStartup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\ShaderChange.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\SpaceBaseInvaders.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Spawn Waves.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\SpawnSystem.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Startup.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\TeraTest.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\testing.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\ToolTips.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Traitor.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Scripts\Tutorial.lua"; DestDir: "{app}\Scripts"; 
Source: "{app}\Shaders\AddTrans.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\AlphaSkin.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\Basic.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\Clouds.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\CubeMap.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\Decal.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\Glow.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\GUI.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\Membrane.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\NewWater.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\PostProcess.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\Quad.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\Shadow.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\Skin.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\SkinFixLight.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\SkinShadow.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\SkyDome.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\Specular.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\STrans.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\Terra.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\Trans.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\VertSpecular.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\ViewShine.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Shaders\Water.fx.fxo"; DestDir: "{app}\Shaders"; 
Source: "{app}\Materials\ArrowMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\AxeMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BaseInvader.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BasicBlindMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BasicDumbMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BasicHappyMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BasicInvMat2.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BasicInvMat3.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BasicMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BomberBlindMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BomberDumbMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BomberMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\Bounding.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BulbTrapMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\Bumpy.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BushMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BushMat2.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BushMat3.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\BusMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\ChurchMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\DefScrapper.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\DrillerBlindMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\DrillerDumbMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\DrillerMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\FanTrapMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\FireTrapMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\Grass.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\Gray.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\HammerTrapMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\HandMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\KamikazeBlindMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\KamikazeDumbMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\KamikazeMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\LargePineTreeMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\LargeTreeMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\LaserTrapMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\LightningMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\Metallic.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\MinerBlindMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\MinerDumbMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\MinerMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\MissileTrapMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\MushRoomMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\MushRoomMat2.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\MushRoomMat3.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\Neon.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\NinjaBlindMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\NinjaDumbMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\NinjaMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\Other.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\Panel.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\Panels.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\ParachuteMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\PineTreeMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\PitMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\PoisonTrapMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\PsychicBlindMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\PsychicDumbMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\PsychicMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\RockMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\SatelliteTrapMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\Shadow.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\SpikerBlindMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\SpikerDumbMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\SpikerMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\SpringTrapMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\SquadBlindMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\SquadDumbMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\SquadMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\StackerBlindMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\StackerDumbMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\StackerMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\TowerMat1.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\TowerMat2.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\TowerMat3.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\TowerMat3E.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\TowerMat4.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\TowerMat5.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\TreeMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\VaseMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\VortexTrapMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\WallMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\WallMat2.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\White.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\Wood.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Materials\ZapperTrapMat.xml"; DestDir: "{app}\Materials"; 
Source: "{app}\Data\AnModelCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\ArrowCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\ArrowTest.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\AuraCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\AuraSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\AxeTrap.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\BaseTower.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\BasicCamera.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\BasicInv.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\BlindCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\BombCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\BomberExplosion.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\BomberInv.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\BoxCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\BulbTrap.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Bus.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Bush1.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Bush2.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Bush3.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\CapeFollower.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Church.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\CogVase.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Constraints.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\CursorCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\DrillerInv.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\DumbCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\DumbEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\DumbSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\DummyBallCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\DustCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\DustExplosionCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\DustExplosionEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\DustExplosionSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\EffectTest.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\ExplosionChunk.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\ExplosionEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\ExplosionEmitSmall.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\ExplosionSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\FanTrap.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\FanWindEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\FanWindSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\FireemitA.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\FireExplosionEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\FireExplosionSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\FireStream.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Firesystem.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\FlameTrap.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\FlameTrapAttackEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\FlameTrapAttackSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\FlameTrapSideSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\FlameTrapTopEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\FlameTrapTopSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\GameCamera.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Hammer.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\InvaderCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\InvaderViewerModel.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\InvDeathCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\InvDeathEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\InvDeathSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\InvSplatEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\InvSplatSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\KamikazeExplosion.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\KamikazeInv.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\KnotCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\LargeExplo.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\LargeExploSmoke.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\LargePineTree.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\LargeTree.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\LaserBullet.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\LaserTrap.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\LevelCog.bin"; DestDir: "{app}\Data"; 
Source: "{app}\Data\LevelCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\LightCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\LightningExplosion.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\LightSnowCell.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\LightSnowCellEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\MapGeneration.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\MinerInv.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\MissileExplosion.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\MissileTrap.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\ModelCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Mushroom.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Mushroom2.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Mushroom3.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\NinjaInv.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\NinjaSmokeCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\NinjaSmokeEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\NinjaSmokeSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\OldSpawnerCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\OnFireCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\OnFireEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\OnFireSimpleEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\OnFireSimpleSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\OnFireSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\ParachuteCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PhysicsBallCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PineTree.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PitDoodad.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PitTrap.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PlaneCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PoisonedCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PoisonedEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PoisonedSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PoisonMist.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PoisonMistEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PoisonMistSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PoisonTrap.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PsychicInv.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PsychicMoveCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PsychicMoveEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PsychicMoveSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PsychicSphereCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PsychicSphereEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\PsychicSphereSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\QuickStartLevelCog.bin"; DestDir: "{app}\Data"; 
Source: "{app}\Data\QuickStartLevelCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\QuietDustExplosionCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\RainCell.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\RainCellEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\RainCellSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\RockDoodad.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\RockDoodad2.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\RockDoodad3.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\RocketBlast.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\RocketEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SatelliteCursor.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SatelliteLaserEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SatelliteLaserSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SatelliteTrap.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SkinTest.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SmallFireEffect.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SmokeEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SmokeSystem.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SnowCell.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SnowCellEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SnowCellSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SparkCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SparkEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SparkingCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SparkingEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SparkingSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SparkSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SpikerInv.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SpringTest2Cog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SpringTest3Cog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SpringTestCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SpringTrap.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SquadInv.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SquadInvx.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\StackerInv.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\StarsCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\StarsEmit.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\StarsSys.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SunlightStream.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\SunlightStreamAmb.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Terra.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Tester.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\TestModelCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\TrapCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\TrapDeathCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\TrapDropper.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\TrapVisualCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Tree1.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Tree2.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Tree3.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Tree4.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Tree5.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\tutorial.bin"; DestDir: "{app}\Data"; 
Source: "{app}\Data\TutorialInvader_Basic.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\TutorialLevel.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Vase.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\VortexTrap.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\WallChunk.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\WallCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\WallCog2.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\XYZCog.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\ZapperTrap.xml"; DestDir: "{app}\Data"; 
Source: "{app}\Data\Effects\AuraStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\BiggestExploEmit.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\BiggestExploSys.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\BlackStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\BlackTransStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\BlindStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\BomberSpeechBubble.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\DeathSpeechBubble.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\DumbStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\DustExplosionStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\ExploEmit.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\ExploFlash.GMF"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\ExplosionStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\ExploSmokeEmit.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\ExploSmokeStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\ExploSmokeSys.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\ExploStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\ExploSys.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\FanWindStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\Fire1Stream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\FireExplosionStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\FireStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\FlameTrapStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\Flash.GMF"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\FlashEffect.gmf"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\FlashEffect.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\GreenSplatStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\InvDeathStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\OnFireStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\PoisonMistStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\PoisonStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\Popup.GMF"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\PsychicSparkleStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\PsychicSparkleStreamShort.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\SatelliteStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\SmallFireEmit.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\SmallFireStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\SmallFireSys.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\SmokeStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\SparkStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\Special Effects.txt"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\SpeechBubble.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\StarsStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\SuckEmit.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\SuckStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\SuckSystem.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\VortexEffect.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\VortexStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\WGreenSplatStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\WhiteStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Effects\WhiteTransStream.xml"; DestDir: "{app}\Data\Effects"; 
Source: "{app}\Data\Levels\campaign1.bin"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign1.xml"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign10.bin"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign10.xml"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign2.bin"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign2.xml"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign3.bin"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign3.xml"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign4.bin"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign4.xml"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign5.bin"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign5.xml"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign6.bin"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign6.xml"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\Campaign7.bin"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\Campaign7.xml"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\Campaign8.bin"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\Campaign8.xml"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign9.bin"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\campaign9.xml"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\introlevel.bin"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\IntroLevel.xml"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\Data\Levels\IntroLevelStuff.bin"; DestDir: "{app}\Data\Levels"; 
Source: "{app}\GUI\ShermlockImpact.dat"; DestDir: "{app}\GUI"; 
Source: "{app}\GUI\ShermlockImpact.dds"; DestDir: "{app}\GUI"; 
Source: "{app}\GUI\ShermlockImpactD.dds"; DestDir: "{app}\GUI"; 
Source: "{app}\GUI\SlideCog.xml"; DestDir: "{app}\GUI"; 
Source: "{app}\GUI\SlideTextBox.xml"; DestDir: "{app}\GUI"; 
Source: "{app}\GUI\SlideWindow.xml"; DestDir: "{app}\GUI"; 
Source: "{app}\GUI\SysVer.dat"; DestDir: "{app}\GUI"; 
Source: "{app}\GUI\SysVer.dds"; DestDir: "{app}\GUI"; 
Source: "{app}\GUI\TitleTextBox.xml"; DestDir: "{app}\GUI"; 
Source: "{app}\MenuData\ArrowImageBox.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\BottomCinemaBarImageBox.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\Button.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\CheckBox.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\CinemaBarsCog.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\CombinedBarsWindow.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\CombinedHUDWindow.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\CombinedMenuWindow.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\CombinedTraitorWindow.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\ComboBox.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\GuiArrowCog.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\HUDCog.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\IconButton.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\ImageBox.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\IntroImageBox.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\IntroImageCog.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\LevelChoiceComboBox.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\MainMenuCog.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\PhysicsModeButton.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\ProgressBar.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\Slider.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\TestWindow.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\TextBox.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\Thumbs.db"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\ToolTipsTextBox.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\ToolTipsTextCog.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\TopCinemaBarImageBox.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\TraitorCog.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\TrapDropButton.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\TrapDropComboBox.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\TrapDropToolBar.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\TrapDropToolBar2.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\TutorialTextBox.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\TutorialTextCog.xml"; DestDir: "{app}\MenuData"; 
Source: "{app}\MenuData\Bonus\BonusImageBox.xml"; DestDir: "{app}\MenuData\Bonus"; 
Source: "{app}\MenuData\Bonus\BonusWindow.xml"; DestDir: "{app}\MenuData\Bonus"; 
Source: "{app}\MenuData\Bonus\ControlsButton.xml"; DestDir: "{app}\MenuData\Bonus"; 
Source: "{app}\MenuData\Bonus\CreditsButton.xml"; DestDir: "{app}\MenuData\Bonus"; 
Source: "{app}\MenuData\Bonus\ExitBonusButton.xml"; DestDir: "{app}\MenuData\Bonus"; 
Source: "{app}\MenuData\Bonus\InvaderViewerButton.xml"; DestDir: "{app}\MenuData\Bonus"; 
Source: "{app}\MenuData\Bonus\ReplayIntroButton.xml"; DestDir: "{app}\MenuData\Bonus"; 
Source: "{app}\MenuData\Controls\ControlsImageBox.xml"; DestDir: "{app}\MenuData\Controls"; 
Source: "{app}\MenuData\Controls\ControlsTextBox.xml"; DestDir: "{app}\MenuData\Controls"; 
Source: "{app}\MenuData\Controls\ControlsWindow.xml"; DestDir: "{app}\MenuData\Controls"; 
Source: "{app}\MenuData\Controls\ExitControlsButton.xml"; DestDir: "{app}\MenuData\Controls"; 
Source: "{app}\MenuData\Credits\CreditsImageBox.xml"; DestDir: "{app}\MenuData\Credits"; 
Source: "{app}\MenuData\Credits\CreditsTextBox.xml"; DestDir: "{app}\MenuData\Credits"; 
Source: "{app}\MenuData\Credits\CreditsWindow.xml"; DestDir: "{app}\MenuData\Credits"; 
Source: "{app}\MenuData\Credits\ExitCreditsButton.xml"; DestDir: "{app}\MenuData\Credits"; 
Source: "{app}\MenuData\GameOver\ExplosionKillsTextBox.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\FavoriteTargetTextBox.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\GameOverTextBox.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\GameOverWindow.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\HideGameOverButton.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\NextLevelButton.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\PhysicsKillsTextBox.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\PointsEarnedTextBox.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\PointsUsedTextBox.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\StatusKillsTextBox.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\SuicideKillsTextBox.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\TimePlayedTextBox.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\TotalKillsTextBox.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\TrapKillsTextBox.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\TrapsDestroyedTextBox.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\GameOver\TrapsPlacedTextBox.xml"; DestDir: "{app}\MenuData\GameOver"; 
Source: "{app}\MenuData\HUD\CreditsIconButton.xml"; DestDir: "{app}\MenuData\HUD"; 
Source: "{app}\MenuData\HUD\CreditsNumTextBox.xml"; DestDir: "{app}\MenuData\HUD"; 
Source: "{app}\MenuData\HUD\HUDWindow.xml"; DestDir: "{app}\MenuData\HUD"; 
Source: "{app}\MenuData\HUD\InGameButton.xml"; DestDir: "{app}\MenuData\HUD"; 
Source: "{app}\MenuData\HUD\KillsImageBox.xml"; DestDir: "{app}\MenuData\HUD"; 
Source: "{app}\MenuData\HUD\KillsNumTextBox.xml"; DestDir: "{app}\MenuData\HUD"; 
Source: "{app}\MenuData\HUD\MiniMapImageBox.xml"; DestDir: "{app}\MenuData\HUD"; 
Source: "{app}\MenuData\HUD\TimeImageBox.xml"; DestDir: "{app}\MenuData\HUD"; 
Source: "{app}\MenuData\HUD\TimeNumTextBox.xml"; DestDir: "{app}\MenuData\HUD"; 
Source: "{app}\MenuData\HUD\TowerHealthImageBox.xml"; DestDir: "{app}\MenuData\HUD"; 
Source: "{app}\MenuData\InGame\BonusButton.xml"; DestDir: "{app}\MenuData\InGame"; 
Source: "{app}\MenuData\InGame\ExitGameButton.xml"; DestDir: "{app}\MenuData\InGame"; 
Source: "{app}\MenuData\InGame\InGameImageBox.xml"; DestDir: "{app}\MenuData\InGame"; 
Source: "{app}\MenuData\InGame\InGameWindow.xml"; DestDir: "{app}\MenuData\InGame"; 
Source: "{app}\MenuData\InGame\OptionsButton.xml"; DestDir: "{app}\MenuData\InGame"; 
Source: "{app}\MenuData\InGame\ResumeGameButton.xml"; DestDir: "{app}\MenuData\InGame"; 
Source: "{app}\MenuData\InGameExit\EndLevelButton.xml"; DestDir: "{app}\MenuData\InGameExit"; 
Source: "{app}\MenuData\InGameExit\GameOverDescTextBox.xml"; DestDir: "{app}\MenuData\InGameExit"; 
Source: "{app}\MenuData\InGameExit\InGameExitWindow.xml"; DestDir: "{app}\MenuData\InGameExit"; 
Source: "{app}\MenuData\InvaderViewer\AnimationNameTextBox.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\ExitInvaderViewerButton.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\InvaderConceptArtImageBox.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\InvaderDescTextBox.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\InvaderGuiModel.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\InvaderIconButton.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\InvaderNameTextBox.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\InvaderStatusImageBox.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\InvaderTextureComboBox.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\InvaderViewerWindow.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\NextAnimationButton.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\NextInvButton.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\PrevInvButton.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\ResetInvButton.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\StatWindow.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\TiltleImageBox.xml"; DestDir: "{app}\MenuData\InvaderViewer"; 
Source: "{app}\MenuData\InvaderViewer\StatWindow\AttackLabelTextBox.xml"; DestDir: "{app}\MenuData\InvaderViewer\StatWindow"; 
Source: "{app}\MenuData\InvaderViewer\StatWindow\AttackStatsTextBox.xml"; DestDir: "{app}\MenuData\InvaderViewer\StatWindow"; 
Source: "{app}\MenuData\InvaderViewer\StatWindow\DefenseLabelTextBox.xml"; DestDir: "{app}\MenuData\InvaderViewer\StatWindow"; 
Source: "{app}\MenuData\InvaderViewer\StatWindow\DefenseStatsTextBox.xml"; DestDir: "{app}\MenuData\InvaderViewer\StatWindow"; 
Source: "{app}\MenuData\InvaderViewer\StatWindow\SpeedLabelTextBox.xml"; DestDir: "{app}\MenuData\InvaderViewer\StatWindow"; 
Source: "{app}\MenuData\InvaderViewer\StatWindow\SpeedStatsTextBox.xml"; DestDir: "{app}\MenuData\InvaderViewer\StatWindow"; 
Source: "{app}\MenuData\LevelChoice\Campaign10Button.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\Campaign1Button.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\Campaign2Button.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\Campaign3Button.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\Campaign4Button.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\Campaign5Button.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\Campaign6Button.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\Campaign7Button.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\Campaign8Button.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\Campaign9Button.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\ExitLevelChoiceButton.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\LevelChoiceImageBox.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\LevelChoiceWindow.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\LevelImageBox.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\QuickStartButton.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelChoice\TutorialButton.xml"; DestDir: "{app}\MenuData\LevelChoice"; 
Source: "{app}\MenuData\LevelVictoryCondition\HideWindowButton.xml"; DestDir: "{app}\MenuData\LevelVictoryCondition"; 
Source: "{app}\MenuData\LevelVictoryCondition\LevelLossCondTextBox.xml"; DestDir: "{app}\MenuData\LevelVictoryCondition"; 
Source: "{app}\MenuData\LevelVictoryCondition\LevelLossDescTextBox.xml"; DestDir: "{app}\MenuData\LevelVictoryCondition"; 
Source: "{app}\MenuData\LevelVictoryCondition\LevelVictoryConditionWindow.xml"; DestDir: "{app}\MenuData\LevelVictoryCondition"; 
Source: "{app}\MenuData\LevelVictoryCondition\LevelVictoryCondTextBox.xml"; DestDir: "{app}\MenuData\LevelVictoryCondition"; 
Source: "{app}\MenuData\LevelVictoryCondition\LevelVictoryDescTextBox.xml"; DestDir: "{app}\MenuData\LevelVictoryCondition"; 
Source: "{app}\MenuData\Options\AntiCheckBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\CancelOptionsButton.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\EnableShadowsCheckBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\ExitOptionsButton.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\FullScreenCheckBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\GraphicalTextBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\InvaderSpeechCheckBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\MaxTextBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\MinTextBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\MusicTextBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\MusicVolumeSlider.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\OptionsImageBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\OptionsWindow.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\PauseMusicCheckBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\QualityComboBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\ResolutionComboBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\ResolutionTextBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\SoundTextBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\SoundVolumeSlider.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\VolumeTextBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Options\VSyncCheckBox.xml"; DestDir: "{app}\MenuData\Options"; 
Source: "{app}\MenuData\Start\BaseInvadersImageBox.xml"; DestDir: "{app}\MenuData\Start"; 
Source: "{app}\MenuData\Start\BonusButton.xml"; DestDir: "{app}\MenuData\Start"; 
Source: "{app}\MenuData\Start\ExitButton.xml"; DestDir: "{app}\MenuData\Start"; 
Source: "{app}\MenuData\Start\OptionsButton.xml"; DestDir: "{app}\MenuData\Start"; 
Source: "{app}\MenuData\Start\StartGameButton.xml"; DestDir: "{app}\MenuData\Start"; 
Source: "{app}\MenuData\Start\StartWindow.xml"; DestDir: "{app}\MenuData\Start"; 
Source: "{app}\MenuData\Start\VersionInfoTextBox.xml"; DestDir: "{app}\MenuData\Start"; 
Source: "{app}\MenuData\Traitor\ToolTipTextBox.xml"; DestDir: "{app}\MenuData\Traitor"; 
Source: "{app}\MenuData\Traitor\TraitorImageBox.xml"; DestDir: "{app}\MenuData\Traitor"; 
Source: "{app}\MenuData\Traitor\TraitorWindow.xml"; DestDir: "{app}\MenuData\Traitor"; 
Source: "{app}\MenuData\Traitor\xAnimateButton.xml"; DestDir: "{app}\MenuData\Traitor"; 
Source: "{app}\MenuData\TraitorEnable\TraitorEnableImageBox.xml"; DestDir: "{app}\MenuData\TraitorEnable"; 
Source: "{app}\MenuData\TraitorEnable\TraitorEnableWindow.xml"; DestDir: "{app}\MenuData\TraitorEnable"; 
Source: "{app}\Music\invasion_haxed.ogg"; DestDir: "{app}\Music"; 
Source: "{app}\Music\invasion_laxed.mp3"; DestDir: "{app}\Music"; 
Source: "{app}\Music\invasion_maxed.mp3"; DestDir: "{app}\Music"; 
Source: "{app}\Music\invasion_resisted.mp3"; DestDir: "{app}\Music"; 
Source: "{app}\Music\invasion_taxed.mp3"; DestDir: "{app}\Music"; 
Source: "{app}\Music\invasion_unopposed.mp3"; DestDir: "{app}\Music"; 
Source: "{app}\Music\moxie_socks.mp3"; DestDir: "{app}\Music"; 
Source: "{app}\SoundSets\AxeTrapSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\BasicInvSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\BomberInvSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\BulbTrapSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\DrillerInvSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\ExplosionSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\FlameTrapSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\HammerTrapSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\InvDeathSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\KamikazeInvSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\LaserTrapSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\MinerInvSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\MissileExplosionSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\MissileTrapSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\NinjaInvSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\PoisonTrapSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\PsychicInvSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\SatelliteSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\SmallExplosionSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\SmokePoofSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\SpikerInvSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\SpringTrapSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\SquadInvSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\StackerInvSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\ThunderSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\SoundSets\ZapperTrapSet.xml"; DestDir: "{app}\SoundSets"; 
Source: "{app}\Readme.txt"; DestDir: "{app}"; 
Source: "{app}\Game Details.doc"; DestDir: "{app}"; 

[Dirs]
Name: "{app}\Config"; 
Name: "{app}\Compositions"; 

[Run]
Filename: "{app}\Game Details.doc"; Flags: shellexec skipifdoesntexist postinstall skipifsilent nowait

[Icons]
Name: "{userdesktop}\BaseInvaders"; Filename: "{app}\CORE.exe"; WorkingDir: "{app}"; 
Name: "{group}\BaseInvaders"; Filename: "{app}\CORE.exe"; WorkingDir: "{app}"; 
Name: "{group}\Uninstall"; Filename: "{uninstallexe}"; 

[CustomMessages]
default.NameAndVersion=%1 version %2
default.AdditionalIcons=Additional icons:
default.CreateDesktopIcon=Create a &desktop icon
default.CreateQuickLaunchIcon=Create a &Quick Launch icon
default.ProgramOnTheWeb=%1 on the Web
default.UninstallProgram=Uninstall %1
default.LaunchProgram=Launch %1
default.AssocFileExtension=&Associate %1 with the %2 file extension
default.AssocingFileExtension=Associating %1 with the %2 file extension...

[Languages]
; These files are stubs
; To achieve better results after recompilation, use the real language files
Name: "default"; MessagesFile: "embedded\default.isl"; 
