G.SetGroup( "Cam" )
local Cam = G.Create( "Data/BasicCamera.xml");
local pos = Vector3(50,60,50);
Cam.SetPosition( pos );

G.File( "Data/Terra.xml");


function MakeObject( objname )
	local obj = G.Create( objname );
	local mpos = G.GetTerrainIntersection();
	obj.SetPosition( mpos );
end

function DooDad()

	if( G.KeyTriggered( "T" ) ) then
		local obj = G.Create( "Data\\BaseTower.xml" );
		local mpos = G.GetTerrainIntersection();
		obj.SetPosition( mpos );
		G.Zapit( obj );
	end	
	
	
	if( G.KeyTriggered( "Y" ) ) then
		local mpos = G.GetTerrainIntersection();
		G.ZapStrike( mpos );
	end	
		
	if( G.KeyTriggered( "1" ) ) then
		MakeObject( "DustExplosion" );
	end	
				
	if( G.KeyTriggered( "2" ) ) then
		MakeObject( "Data\\InvDeathCog.xml" );
	end	

	if( G.KeyTriggered( "3" ) ) then
		MakeObject( "Data\\PsychicSphereCog.xml" );
	end		

	if( G.KeyTriggered( "E" ) ) then
		MakeObject( "Data\\PsychicMoveCog.xml" );
	end		
		
	if( G.KeyTriggered( "4" ) ) then
		MakeObject( "Data\\NinjaSmokeCog.xml" );
	end	
	if( G.KeyTriggered( "5" ) ) then
		MakeObject( "Data\\AuraCog.xml" );
	end	
	
	if( G.KeyTriggered( "6" ) ) then
		MakeObject( "Data\\PoisonedCog.xml" );
	end								
							
	if( G.KeyTriggered( "7" ) ) then
		MakeObject( "Data\\OnFireCog.xml" );
	end	
	
	if( G.KeyTriggered( "8" ) ) then
		MakeObject( "Data\\DumbCog.xml" );
	end	

	if( G.KeyTriggered( "9" ) ) then
		MakeObject( "Data\\SparkCog.xml" );
	end	
			
	if( G.KeyTriggered( "0" ) ) then
		MakeObject( "Data\\StarsCog.xml" );
	end	
	
	if( G.KeyTriggered( "R" ) ) then
		MakeObject( "Data\\RainCell.xml" );
	end	
			
	if( G.KeyTriggered( "C" ) ) then
		G.TerraInfo( "test.xml" );
	end		
		
end

function ScreenCapFunc()	
	if( G.KeyTriggered( "SysReq" ) ) then
		G.ScreenCap()
	end
end
GMain["ScreenCapFunc"] = ScreenCapFunc;


GMain[ "DooDad" ] = DooDad;		