GMain = {};
GRoutines = {};
--[[  ]]--

-- memUsed = 0
-- threshold = 0
function GUpdate()

--	memUsed, threshold = gcinfo()
--	G.Mes( tostring( memUsed ) .. " KB Used " .. tostring( threshold ) .. " Threshold" )


	if( G.KeyTriggered( "M" ) ) then
		G.TerraInfo( "test.xml" );
	end	
	
	
	
	for i,func in pairs (GMain) do
		func();
	end	
	for i,co in pairs (GRoutines) do
		local con = coroutine.resume(co)
		if( con == false ) then
			GRoutines[i] = nil;
		end			
	end		
end

function CreateCoroutine( func )
	local co = coroutine.create( func ); 
	table.insert( GRoutines , co );
end



	
------------------------------------------------------------------------------
--						GAME LOGIC WAIT FUNCTIONS
------------------------------------------------------------------------------

function Wait( time )
	local starttime = CoreTime;	
	while( CoreTime - starttime < time ) do	
		coroutine.yield();	
	end
end

function GameWait( time )
	local starttime = GameTime;	
	while( GameTime - starttime < time ) do	
		coroutine.yield();	
	end
end

function GameWaitOrMoney( time )
	local starttime = GameTime;	
	while( GameTime - starttime < time and Points > 10 ) do	
		coroutine.yield();	
	end
end

function InvadersKilledWait( count )
	while(Kills < count) do
		coroutine.yield();
	end
end

function PointsWait( count )
	while(Points > count) do
		coroutine.yield();
	end
end

function WaitOnTimeOrPoints( time )
	local starttime = GameTime;	
	local startpoints = Points;
	coroutine.yield();
	while( GameTime - starttime < time and startpoints == Points) do
		coroutine.yield();
	end
end

-- Waits until all invaders are dead ( or the time passes )
function WaitForClearEnemiesOrTime( time )
	local starttime = GameTime;
	while( GameTime - starttime < time and NumInvaders > 0 ) do	
		coroutine.yield();	
	end	
end

function WaitForClearEnemies()
	while( NumInvaders > 0 ) do	
		coroutine.yield();	
	end	
end

function WaitForTimeOrKills( time, kills )
--	local startKills = Kills;
	local starttime = GameTime;
	while( GameTime - starttime < time and Kills < kills ) do			-- Kills - startKills < kills ) do	
		-- G.Mes( tostring( Kills - startKills ) .. " " .. tostring( kills ) )
		coroutine.yield();	
	end
end
