--Common Level Start Code
G.Create( "MenuData/HudCog.xml" );
G.Create( "Data/GameCamera.xml" );
G.Create( "Data/CursorCog.xml" );

--MainLevel = G.Create( "foo.xml" );
--MainLevel = G.Create( "Data/LevelCog.xml" );
MainLevel = G.Create( "Campaign2.xml" );

MainLevel.CreateLevel();


G.SetInvSpeed( 20 );
dofile( "Scripts/LevelOneSpawners.lua" );
G.PlayMusic();
HUD.EnterLevel();
G.SetGameState( InLevel );
G.SetPoints( 100 );


HUD.Message( "VictoryCondition" , "SetText", "Kill 100 invaders"  );
HUD.Message( "LossCondition" , "SetText", "If the Tower falls you lose" );


function LevelExitDesc()
	if ( GameState == QuitLevel )then
		G.ActiveBackGround( 1 );
		return "YOU QUIT!";
	elseif(  GameState == Victory )then
		G.ActiveBackGround( 1 );
		return "YOU WON!";
	elseif( GameState == Defeat )then
		G.ActiveBackGround( 2 );
		return "YOU LOST!";
	end
end
	
function LevelVictory()	

	if( Kills >= 100 ) then
		G.SetGameState( Victory );		
	end
			
	local tower = G.GetCogName("Tower");
	
	--if( not tower.IsValid() ) then
	--	G.SetGameState( Defeat );	
	--end
			
	if( not( GameState == InLevel ) ) then
		dofile( "Scripts/GameOver.lua" );		
		gameovertext = LevelExitDesc();
		GameOverScreen( gameovertext );
		GMain["LevelVictory"] = nil;
	end		
	
end

GMain["LevelVictory"] = LevelVictory;
