G.SetGroup( "Cam" )
local Cam = G.Create( "Data/BasicCamera.xml");
local pos = Vector3(50,60,50);
Cam.SetPosition( pos );
G.File( "Data/Terra.xml");


function DooDad()
	if( G.KeyTriggered( "F" ) ) then
		local d = G.Create( "Data/LargePineTree.xml" );
		local mpos = G.GetTerrainIntersection();
		d.SetPosition( mpos );
	end		
	
	if( G.KeyTriggered( "R" ) ) then
		local d = G.Create( "Data/Effects/VortexEffect.xml" );
		local mpos = G.GetTerrainIntersection();
		d.SetPosition( mpos );
	end			
		
end
	



function MonoChrome()
	G.DoPostPass( "MonoChrome",  1, 1, 0 );
end


function MonoBlur()
	G.BlurBuffer( 1 , 5);
	G.DoPostPass( "MonoChrome",  1, 1, 0 );	
end

function Test()
	G.DoPostPass( "DownSample",  1, 1, 2 );
	G.DoPostPass( "Threshold",  2, 2, 3 );
	G.BlurBuffer( 3 , 5);
	--G.DoPostPass( "MonoChrome",  3, 3, 0 );			
	--G.DoPostPass( "Blend" ,		 2, 2, 0 );	
	G.DoPostPass( "FinalGlare" , 1, 3, 0 );
end


function Invert()
	G.DoPostPass( "Invert",  1, 1, 0 );
end
		
			
GMain[ "DooDad" ] = DooDad;		

function ScreenCapFunc()
			
	if( G.KeyTriggered( "C" ) ) then
		G.ScreenCap()
	end
	
	if( G.KeyTriggered( "N" ) ) then
		G.LightCycle()
	end

	if( G.KeyTriggered( "I" ) ) then
		G.IncreaseLight()
	end
	
	
	if( G.KeyTriggered( "K" ) ) then
		G.DecreaseLight()
	end
	
end

GMain["ScreenCapFunc"] = ScreenCapFunc;

